﻿#!/usr/bin/env python
# -*- coding: utf-8 -*-

###
### Usage:
# > ./ccch_scan -a ARFCN -i 127.0.0.1
# > tcpdump -l -ilo -nXs0 udp and port 4729 | python2 -u show_gsmtap_sms.py
#

import sys
import base64
import urllib
import urllib2
sys.path.insert(0, 'protocol_parser.zip')
from protocol_parser import *



debug_printf = lambda str: sys.stdout.write(str)

def process_sms_tpdu(sms_payload):
	#hexdump(sms_payload)
	try:
		sms = SMS(sms_payload)
		tpdu = TPDU(sms.get_tpdu())
		debug_printf("[SMS from %s] %s\n" % (tpdu.TP_origin, tpdu.get_data()))
		send_to_server(tpdu.TP_origin, tpdu.get_data())
	except Exception, e:
		#print e
		pass

last_sms_payload = ""

def handle_tcpdump_buffer(title, buffer):
	if (len(buffer.strip()) == 0):
		return

	try:
		raw_struct = str2rawbuf(buffer)
		udp_packet = UDP(raw_struct)
		gsm_payload = udp_packet.get_payload()
		#hexdump(gsm_payload)

		gsmtap = GSMTAP(gsm_payload)
		lapdm = LAPDm(gsmtap.get_payload())

		if (gsmtap.channel_type == 8) and (lapdm.sapi == 3):		# TS 04.06, 3.3.3, SAPI: 3 - Short message service
			#debug_printf("LINK[%d] ARFCN=%d TIME_SLOT=%d CHANNEL=%d, N(R)=%d N(S)=%d, segment more[%d], payload len=%d\n" % \
						#(gsmtap.link, gsmtap.arfcn, gsmtap.time_slot, gsmtap.channel_type, lapdm.n_r, lapdm.n_s, lapdm.has_more, lapdm.length))

			global last_sms_payload
			last_sms_payload += lapdm.get_data()
			if (lapdm.has_more == 0):
				process_sms_tpdu(last_sms_payload)
				last_sms_payload = ""
	except Exception, e:
		#debug_printf("[ERROR] decode error: %s\n" % e)
		#debug_printf("%s\n" % buffer)
		pass

def main():
	stdin_process = StdinTcpdump(handle_tcpdump_buffer)
	stdin_process.run()

main()
